import java.util.Scanner;
import java.util.Arrays;
public class SearchingApp {
	public static void main(String[] args) {		
		Scanner scan = new Scanner(System.in);
		int[] pool = {1, 5, 8, 10};
		int target;

		System.out.println("Enter a target value: ");
		target = scan.nextInt();

		if(linearSearch(pool, target)) {
			System.out.println(target + " found using linear search");
		} else {
			System.out.println(target + " not found using linear search");
		}

		if(binarySearch(pool, target)) {
			System.out.println(target + " found using binary search");
		} else {
			System.out.println(target + " not found using binary search");
		}
		
		if(Arrays.binarySearch(pool, target) >= 0) {
			System.out.println(target + " found using built-in function");
		} else {
			System.out.println(target + " not found using built-in function");
		}

	}

	private static boolean linearSearch(int[] pool, int target) {
		boolean found = false;
		int idx = 0;

		while(!found && idx < pool.length) {
			if(pool[idx] == target) {
				found = true;
			} else {
				idx++;
			}
		}

		return found;
	}

	private static boolean binarySearch(int[] pool, int target) {
		int left = 0, right = pool.length - 1;
		int middle;
		boolean found = false;
		while(!found && left <= right) {
			middle= left + (right - left) / 2;

			if(pool[middle] == target) {
				found = true;
			} else if(pool[middle] < target) {
				left = middle + 1;
			} else {
				right = middle - 1;
			}
		}

		return found;


	}




}